<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2011 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc This report displays a overview of your top keywords
*/
$reports["_TOP_KEYWORDS"] = Array(
	"ClassName" => "TopKeywords", 
	"Category" => "_INCOMING_TRAFFIC", 
	"icon" => "images/icons/32x32/topkeywords.png",
	"Options" => "daterangeField,displaymode,trafficsource,search,limit,columnSelector",
	"Filename" => "top_keywords",
	"Distribution" => "Standard",
	"Order" => 5,
	"ReportVersion" => 1.0,
	"MinimumVersion" => 3.0,
	"EmailAlerts" => true
);

class TopKeywords extends Report {

	function Settings() {
		$this->DefaultDisplay = "table";
		$this->DisplayModes = "table,pie";
		$this->showfields = _KEYWORDS.','._VISITORS.','._HITS;
		$this->help = _TOP_KEYWORDS_DESC;
		$this->actionmenu_type = 'keyword';
	}
	
	function DefineQuery() {
		global $db,$nc;

	    if(!empty($this->search)) {
            $searchst = $this->SearchMatchingIDs($this->search, "keywords", $this->searchmode, $this->profile->tablename_keywords);
        } else {
			$searchst = "";
		}
		
		$emptykeyword = getID('','keyword');
		
		$subquery = subsetDataToSourceID("select {$nc} keywords, count(distinct visitorid) as visitors, count(*) as hits from {$this->profile->tablename} where timestamp >= ". $db->quote($this->from) ." and timestamp <= ". $db->quote($this->to) ." and crawl=0 and keywords != '{$emptykeyword}' {$searchst} group by keywords order by visitors desc limit ". addslashes($this->limit), $this->trafficsource);

		$query = "SELECT {$nc} k.keywords, sq.visitors, sq.hits from ({$subquery}) as sq, {$this->profile->tablename_keywords} as k WHERE sq.keywords=k.id";

		$this->applytrafficsource = false;
		return $query;
	}
    
    
}
?>
